#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#define check(A, M, ...) if(!(A)) {\
		printf("[ERROR] (%s:%d) " M "\n", __FILE__, __LINE__, ##__VA_ARGS__); \
	} else { \
		printf("Success\n");\
	}

int normal_copy(char *from, char *to, int count)
{
	int i = 0;
	for (i = 0; i < count; i++) {
		to[i] = from[i];
	}
	return i;
}

int duffs_device(char *from, char *to, int count)
{
	int n = (count + 7) / 8;
	switch (count % 8) {
		case 0:
		do {
			*to++ = *from++;
		case 7:
			*to++ = *from++;
		case 6:
			*to++ = *from++;
		case 5:
			*to++ = *from++;
		case 4:
			*to++ = *from++;
		case 3:
			*to++ = *from++;
		case 2:
			*to++ = *from++;
		case 1:
			*to++ = *from++;
		} while (--n > 0);
	}
	return count;
}

bool valid_copy(char *data, int count, char expects)
{
	int i = 0;
	for (i = 0; i < count; i++) {
		if (data[i] != expects) {
			printf("%c %c\n", data[i], expects);
			return false;
		}
	}
	return true;
}

int main(int argc, char *argv[])
{
	char from[1000] = { 'a' };
	char to[1000] = { 'c' };
	int rc = 0;

	memset(from, 'x', 1000);
	memset(to, 'y', 1000);
	check(valid_copy(to, 1000, 'y'), "Not initialized right");

	// use normal copy to
	rc = normal_copy(from, to, 1000);
	check(rc == 1000, "Normal copy failed: %d", rc);
	check(valid_copy(to, 1000, 'x'), "Normal copy failed.");

	memset(to, 'y', 1000);
	rc = duffs_device(from, to, 1000);
	check(rc == 1000, "Duff's device failed: %d", rc);
	check(valid_copy(to, 1000, 'x'), "Duff's device failed copy");

	return 0;
}
