#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>

struct person {
	char *name;
	int age;
	int height;
	int weight;
};

struct person *person_create(struct person *who, char *name, int age, int height, int weight)
{
	assert(who != NULL);

	who->name = strdup(name);
	who->age = age;
	who->height = height;
	who->weight = weight;

	return who;
}

void person_print(struct person *who)
{
	printf("Name: %s\n", who->name);
	printf("\tAge: %d\n", who->age);
	printf("\tHeight: %d\n", who->height);
	printf("\tWeight: %d\n", who->weight);
}

int main(int argc, char *argv[])
{
	struct person joe;
	(void)person_create(&joe, "Joe Alex", 32, 64, 140);

	printf("Joe is at memory location %p:\n", joe);
	person_print(&joe);

	joe.age += 20;
	person_print(&joe);

	return 0;
}
